/* ispdef.h */

/*
 *	
 *	Copyright (c) 1992
 *	Digital Equipment Corporation, Maynard, Massachusetts 01754
 *	
 *	This software is furnished under a license for use only on a single computer
 *	system  and  may be  copied  only  with the inclusion of the above copyright
 *	notice.  This software, or  any other copies thereof, may not be provided or
 *	otherwise made  available  to any other person except for use on such system
 *	and to one who agrees to these license terms.  Title to and ownership of the
 *	software shall at all times remain in DEC.
 *	
 *	The information  in  this software  is  subject to change without notice and
 *	should not be construed as a commitment by Digital Equipment Corporation.
 *	
 *	DEC  assumes no responsibility for the use or reliability of its software on
 *	equipment which is not supplied by DEC.
 *	
 *	
 *	REVISION HISTORY:		
 *	
 *	Edit	Date		Who	Summary of change
 *	----	---------	---	-----------------------------------------------
 *	3    	12-Aug-92	GPC	Simplify for use with PVC
 *	2	15-May-89	SJM	Convert to to EVAX (64 bit) instruction set.
 *	1   	19-Dec-88	SJM	File created - PRISM scalar instruction set.
 */

#ifndef ISPDEF_H
#define ISPDEF_H 1



/* define constants for use by ISP model */

#define DO_DISP_BY_MEM_FUNC	(-3)
#define DO_DISP_BY_FPU_FUNC	(-2)
#define DO_DISP_BY_FUNC	(-1)
#define DO_UNDEFINED	(0)
#define DO_ADDD		(1)
#define DO_ADDDC	(2)
#define DO_ADDDS	(3)
#define DO_ADDDSC	(4)
#define DO_ADDDSU	(5)
#define DO_ADDDSUC	(6)
#define DO_ADDDU	(7)
#define DO_ADDDUC	(8)
#define DO_ADDF		(9)
#define DO_ADDFC	(10)
#define DO_ADDFS	(11)
#define DO_ADDFSC	(12)
#define DO_ADDFSU	(13)
#define DO_ADDFSUC	(14)
#define DO_ADDFU	(15)
#define DO_ADDFUC	(16)
#define DO_ADDG		(17)
#define DO_ADDGC	(18)
#define DO_ADDGS	(19)
#define DO_ADDGSC	(20)
#define DO_ADDGSU	(21)
#define DO_ADDGSUC	(22)
#define DO_ADDGU	(23)
#define DO_ADDGUC	(24)
#define DO_ADDL		(25)
#define DO_ADDLV	(26)
#define DO_ADDQ		(27)
#define DO_ADDQV	(28)
#define DO_ADDS		(29)
#define DO_ADDSC	(30)
#define DO_ADDSM	(31)
#define DO_ADDSP	(32)
#define DO_ADDSSU	(33)
#define DO_ADDSSUC	(34)
#define DO_ADDSSUI	(35)
#define DO_ADDSSUIC	(36)
#define DO_ADDSSUIM	(37)
#define DO_ADDSSUIP	(38)
#define DO_ADDSSUM	(39)
#define DO_ADDSSUP	(40)
#define DO_ADDSU	(41)
#define DO_ADDSUC	(42)
#define DO_ADDSUM	(43)
#define DO_ADDSUP	(44)
#define DO_ADDT		(45)
#define DO_ADDTC	(46)
#define DO_ADDTM	(47)
#define DO_ADDTP	(48)
#define DO_ADDTSU	(49)
#define DO_ADDTSUC	(50)
#define DO_ADDTSUI	(51)
#define DO_ADDTSUIC	(52)
#define DO_ADDTSUIM	(53)
#define DO_ADDTSUIP	(54)
#define DO_ADDTSUM	(55)
#define DO_ADDTSUP	(56)
#define DO_ADDTU	(57)
#define DO_ADDTUC	(58)
#define DO_ADDTUM	(59)
#define DO_ADDTUP	(60)
#define DO_AND		(61)
#define DO_BEQ		(62)
#define DO_BFEQ		(63)
#define DO_BFGE		(64)
#define DO_BFGT		(65)
#define DO_BFLE		(66)
#define DO_BFLT		(67)
#define DO_BFNE		(68)
#define DO_BGE		(69)
#define DO_BGT		(70)
#define DO_BIC		(71)
#define DO_BLBC		(72)
#define DO_BLBS		(73)
#define DO_BLE		(74)
#define DO_BLT		(75)
#define DO_BNE		(76)
#define DO_CMOVEQ	(77)
#define DO_CMOVGE	(78)
#define DO_CMOVGT	(79)
#define DO_CMOVLBC	(80)
#define DO_CMOVLBS	(81)
#define DO_CMOVLE	(82)
#define DO_CMOVLT	(83)
#define DO_CMOVNE	(84)
#define DO_CMPB		(85)
#define DO_CMPBGE	(86)
#define DO_CMPDEQ	(87)
#define DO_CMPDEQS	(88)
#define DO_CMPDGE	(89)
#define DO_CMPDGES	(90)
#define DO_CMPDGT	(91)
#define DO_CMPDGTS	(92)
#define DO_CMPDLE	(93)
#define DO_CMPDLES	(94)
#define DO_CMPDLT	(95)
#define DO_CMPDLTS	(96)
#define DO_CMPDNE	(97)
#define DO_CMPDNES	(98)
#define DO_CMPEQ	(99)
#define DO_CMPFEQ	(100)
#define DO_CMPFEQS	(101)
#define DO_CMPFGE	(102)
#define DO_CMPFGES	(103)
#define DO_CMPFGT	(104)
#define DO_CMPFGTS	(105)
#define DO_CMPFLE	(106)
#define DO_CMPFLES	(107)
#define DO_CMPFLT	(108)
#define DO_CMPFLTS	(109)
#define DO_CMPFNE	(110)
#define DO_CMPFNES	(111)
#define DO_CMPGE	(112)
#define DO_CMPGEQ	(113)
#define DO_CMPGEQS	(114)
#define DO_CMPGGE	(115)
#define DO_CMPGGES	(116)
#define DO_CMPGGT	(117)
#define DO_CMPGGTS	(118)
#define DO_CMPGLE	(119)
#define DO_CMPGLES	(120)
#define DO_CMPGLT	(121)
#define DO_CMPGLTS	(122)
#define DO_CMPGNE	(123)
#define DO_CMPGNES	(124)
#define DO_CMPGT	(125)
#define DO_CMPLE	(126)
#define DO_CMPLT	(127)
#define DO_CMPNE	(128)
#define DO_CMPSEQ	(129)
#define DO_CMPSEQSU	(130)
#define DO_CMPSLE	(131)
#define DO_CMPSLESU	(132)
#define DO_CMPSLT	(133)
#define DO_CMPSLTSU	(134)
#define DO_CMPSUN	(135)
#define DO_CMPSUNSU	(136)
#define DO_CMPTEQ	(137)
#define DO_CMPTEQSU	(138)
#define DO_CMPTLE	(139)
#define DO_CMPTLESU	(140)
#define DO_CMPTLT	(141)
#define DO_CMPTLTSU	(142)
#define DO_CMPTUN	(143)
#define DO_CMPTUNSU	(144)
#define DO_CMPUGE	(145)
#define DO_CMPUGT	(146)
#define DO_CMPULE	(147)
#define DO_CMPULT	(148)
#define DO_CPYS		(149)
#define DO_CPYSE	(150)
#define DO_CPYSEE	(151)
#define DO_CPYSN	(152)
#define DO_CVTDF	(153)
#define DO_CVTDFC	(154)
#define DO_CVTDFS	(155)
#define DO_CVTDFSC	(156)
#define DO_CVTDFSU	(157)
#define DO_CVTDFSUC	(158)
#define DO_CVTDFU	(159)
#define DO_CVTDFUC	(160)
#define DO_CVTDL	(161)
#define DO_CVTDLC	(162)
#define DO_CVTDLS	(163)
#define DO_CVTDLSC	(164)
#define DO_CVTDLSV	(165)
#define DO_CVTDLSVC	(166)
#define DO_CVTDLV	(167)
#define DO_CVTDLVC	(168)
#define DO_CVTDQ	(169)
#define DO_CVTDQC	(170)
#define DO_CVTDQS	(171)
#define DO_CVTDQSC	(172)
#define DO_CVTDQSV	(173)
#define DO_CVTDQSVC	(174)
#define DO_CVTDQV	(175)
#define DO_CVTDQVC	(176)
#define DO_CVTFD	(177)
#define DO_CVTFDC	(178)
#define DO_CVTFDS	(179)
#define DO_CVTFDSC	(180)
#define DO_CVTFDSU	(181)
#define DO_CVTFDSUC	(182)
#define DO_CVTFDU	(183)
#define DO_CVTFDUC	(184)
#define DO_CVTFG	(185)
#define DO_CVTFGC	(186)
#define DO_CVTFGS	(187)
#define DO_CVTFGSC	(188)
#define DO_CVTFGSU	(189)
#define DO_CVTFGSUC	(190)
#define DO_CVTFGU	(191)
#define DO_CVTFGUC	(192)
#define DO_CVTFL	(193)
#define DO_CVTFLC	(194)
#define DO_CVTFLS	(195)
#define DO_CVTFLSC	(196)
#define DO_CVTFLSV	(197)
#define DO_CVTFLSVC	(198)
#define DO_CVTFLV	(199)
#define DO_CVTFLVC	(200)
#define DO_CVTFQ	(201)
#define DO_CVTFQC	(202)
#define DO_CVTFQS	(203)
#define DO_CVTFQSC	(204)
#define DO_CVTFQSV	(205)
#define DO_CVTFQSVC	(206)
#define DO_CVTFQV	(207)
#define DO_CVTFQVC	(208)
#define DO_CVTGF	(209)
#define DO_CVTGFC	(210)
#define DO_CVTGFS	(211)
#define DO_CVTGFSC	(212)
#define DO_CVTGFSU	(213)
#define DO_CVTGFSUC	(214)
#define DO_CVTGFU	(215)
#define DO_CVTGFUC	(216)
#define DO_CVTGL	(217)
#define DO_CVTGLC	(218)
#define DO_CVTGLS	(219)
#define DO_CVTGLSC	(220)
#define DO_CVTGLSV	(221)
#define DO_CVTGLSVC	(222)
#define DO_CVTGLV	(223)
#define DO_CVTGLVC	(224)
#define DO_CVTGQ	(225)
#define DO_CVTGQC	(226)
#define DO_CVTGQS	(227)
#define DO_CVTGQSC	(228)
#define DO_CVTGQSV	(229)
#define DO_CVTGQSVC	(230)
#define DO_CVTGQV	(231)
#define DO_CVTGQVC	(232)
#define DO_CVTLD	(233)
#define DO_CVTLDC	(234)
#define DO_CVTLDS	(235)
#define DO_CVTLDSC	(236)
#define DO_CVTLF	(237)
#define DO_CVTLFC	(238)
#define DO_CVTLFS	(239)
#define DO_CVTLFSC	(240)
#define DO_CVTLG	(241)
#define DO_CVTLGC	(242)
#define DO_CVTLGS	(243)
#define DO_CVTLGSC	(244)
#define DO_CVTLQ	(245)
#define DO_CVTLS	(246)
#define DO_CVTLSC	(247)
#define DO_CVTLSM	(248)
#define DO_CVTLSP	(249)
#define DO_CVTLSSU	(250)
#define DO_CVTLSSUC	(251)
#define DO_CVTLSSUI	(252)
#define DO_CVTLSSUIC	(253)
#define DO_CVTLSSUIM	(254)
#define DO_CVTLSSUIP	(255)
#define DO_CVTLSSUM	(256)
#define DO_CVTLSSUP	(257)
#define DO_CVTLT	(258)
#define DO_CVTLTC	(259)
#define DO_CVTLTM	(260)
#define DO_CVTLTP	(261)
#define DO_CVTLTSU	(262)
#define DO_CVTLTSUC	(263)
#define DO_CVTLTSUI	(264)
#define DO_CVTLTSUIC	(265)
#define DO_CVTLTSUIM	(266)
#define DO_CVTLTSUIP	(267)
#define DO_CVTLTSUM	(268)
#define DO_CVTLTSUP	(269)
#define DO_CVTQD	(270)
#define DO_CVTQDC	(271)
#define DO_CVTQDS	(272)
#define DO_CVTQDSC	(273)
#define DO_CVTQF	(274)
#define DO_CVTQFC	(275)
#define DO_CVTQFS	(276)
#define DO_CVTQFSC	(277)
#define DO_CVTQG	(278)
#define DO_CVTQGC	(279)
#define DO_CVTQGS	(280)
#define DO_CVTQGSC	(281)
#define DO_CVTQL	(282)
#define DO_CVTQLV	(283)
#define DO_CVTQS	(284)
#define DO_CVTQSC	(285)
#define DO_CVTQSM	(286)
#define DO_CVTQSP	(287)
#define DO_CVTQSSU	(288)
#define DO_CVTQSSUC	(289)
#define DO_CVTQSSUI	(290)
#define DO_CVTQSSUIC	(291)
#define DO_CVTQSSUIM	(292)
#define DO_CVTQSSUIP	(293)
#define DO_CVTQSSUM	(294)
#define DO_CVTQSSUP	(295)
#define DO_CVTQT	(296)
#define DO_CVTQTC	(297)
#define DO_CVTQTM	(298)
#define DO_CVTQTP	(299)
#define DO_CVTQTSU	(300)
#define DO_CVTQTSUC	(301)
#define DO_CVTQTSUI	(302)
#define DO_CVTQTSUIC	(303)
#define DO_CVTQTSUIM	(304)
#define DO_CVTQTSUIP	(305)
#define DO_CVTQTSUM	(306)
#define DO_CVTQTSUP	(307)
#define DO_CVTSL	(308)
#define DO_CVTSLC	(309)
#define DO_CVTSLSV	(310)
#define DO_CVTSLSVC	(311)
#define DO_CVTSLSVI	(312)
#define DO_CVTSLSVIC	(313)
#define DO_CVTSLV	(314)
#define DO_CVTSLVC	(315)
#define DO_CVTSQ	(316)
#define DO_CVTSQC	(317)
#define DO_CVTSQSV	(318)
#define DO_CVTSQSVC	(319)
#define DO_CVTSQSVI	(320)
#define DO_CVTSQSVIC	(321)
#define DO_CVTSQV	(322)
#define DO_CVTSQVC	(323)
#define DO_CVTST	(324)
#define DO_CVTSTS	(324)
#define DO_CVTSTC	(325)
#define DO_CVTSTM	(326)
#define DO_CVTSTP	(327)
#define DO_CVTSTSU	(328)
#define DO_CVTSTSUC	(329)
#define DO_CVTSTSUI	(330)
#define DO_CVTSTSUIC	(331)
#define DO_CVTSTSUIM	(332)
#define DO_CVTSTSUIP	(333)
#define DO_CVTSTSUM	(334)
#define DO_CVTSTSUP	(335)
#define DO_CVTSTU	(336)
#define DO_CVTSTUC	(337)
#define DO_CVTSTUM	(338)
#define DO_CVTSTUP	(339)
#define DO_CVTTL	(340)
#define DO_CVTTLC	(341)
#define DO_CVTTLSV	(342)
#define DO_CVTTLSVC	(343)
#define DO_CVTTLSVI	(344)
#define DO_CVTTLSVIC	(345)
#define DO_CVTTLV	(346)
#define DO_CVTTLVC	(347)
#define DO_CVTTQ	(348)
#define DO_CVTTQC	(349)
#define DO_CVTTQSV	(350)
#define DO_CVTTQSVC	(351)
#define DO_CVTTQSVI	(352)
#define DO_CVTTQSVIC	(353)
#define DO_CVTTQV	(354)
#define DO_CVTTQVC	(355)
#define DO_CVTTS	(356)
#define DO_CVTTSC	(357)
#define DO_CVTTSM	(358)
#define DO_CVTTSP	(359)
#define DO_CVTTSSU	(360)
#define DO_CVTTSSUC	(361)
#define DO_CVTTSSUI	(362)
#define DO_CVTTSSUIC	(363)
#define DO_CVTTSSUIM	(364)
#define DO_CVTTSSUIP	(365)
#define DO_CVTTSSUM	(366)
#define DO_CVTTSSUP	(367)
#define DO_CVTTSU	(368)
#define DO_CVTTSUC	(369)
#define DO_CVTTSUM	(370)
#define DO_CVTTSUP	(371)
#define DO_DIV		(372)
#define DO_DIVD		(373)
#define DO_DIVDC	(374)
#define DO_DIVDS	(375)
#define DO_DIVDSC	(376)
#define DO_DIVDSU	(377)
#define DO_DIVDSUC	(378)
#define DO_DIVDU	(379)
#define DO_DIVDUC	(380)
#define DO_DIVF		(381)
#define DO_DIVFC	(382)
#define DO_DIVFS	(383)
#define DO_DIVFSC	(384)
#define DO_DIVFSU	(385)
#define DO_DIVFSUC	(386)
#define DO_DIVFU	(387)
#define DO_DIVFUC	(388)
#define DO_DIVG		(389)
#define DO_DIVGC	(390)
#define DO_DIVGS	(391)
#define DO_DIVGSC	(392)
#define DO_DIVGSU	(393)
#define DO_DIVGSUC	(394)
#define DO_DIVGU	(395)
#define DO_DIVGUC	(396)
#define DO_DIVS		(397)
#define DO_DIVSC	(398)
#define DO_DIVSM	(399)
#define DO_DIVSP	(400)
#define DO_DIVSSU	(401)
#define DO_DIVSSUC	(402)
#define DO_DIVSSUI	(403)
#define DO_DIVSSUIC	(404)
#define DO_DIVSSUIM	(405)
#define DO_DIVSSUIP	(406)
#define DO_DIVSSUM	(407)
#define DO_DIVSSUP	(408)
#define DO_DIVSU	(409)
#define DO_DIVSUC	(410)
#define DO_DIVSUM	(411)
#define DO_DIVSUP	(412)
#define DO_DIVT		(413)
#define DO_DIVTC	(414)
#define DO_DIVTM	(415)
#define DO_DIVTP	(416)
#define DO_DIVTSU	(417)
#define DO_DIVTSUC	(418)
#define DO_DIVTSUI	(419)
#define DO_DIVTSUIC	(420)
#define DO_DIVTSUIM	(421)
#define DO_DIVTSUIP	(422)
#define DO_DIVTSUM	(423)
#define DO_DIVTSUP	(424)
#define DO_DIVTU	(425)
#define DO_DIVTUC	(426)
#define DO_DIVTUM	(427)
#define DO_DIVTUP	(428)
#define DO_DIVV		(429)
#define DO_DRAINT	(430)
#define DO_EPICODE	(431)
#define DO_EQV		(432)
#define DO_EXTBH	(433)
#define DO_EXTBL	(434)
#define DO_EXTLH	(435)
#define DO_EXTLL	(436)
#define DO_EXTQH	(437)
#define DO_EXTQL	(438)
#define DO_EXTWH	(439)
#define DO_EXTWL	(440)
#define DO_FCMOVEQ	(441)
#define DO_FCMOVGE	(442)
#define DO_FCMOVGT	(443)
#define DO_FCMOVLE	(444)
#define DO_FCMOVLT	(445)
#define DO_FCMOVNE	(446)
#define DO_FETCH	(447)
#define DO_FETCH_M	(448)
#define DO_FLBC		(449)
#define DO_BR		(450)
#define DO_HW_LD	(451)
#define DO_HW_MFPR	(452)
#define DO_HW_MTPR	(453)
#define DO_HW_REI	(454)
#define DO_HW_RET	(DO_HW_REI)
#define DO_HW_ST	(455)
#define DO_INSBH	(456)
#define DO_INSBL	(457)
#define DO_INSLH	(458)
#define DO_INSLL	(459)
#define DO_INSQH	(460)
#define DO_INSQL	(461)
#define DO_INSWH	(462)
#define DO_INSWL	(463)
#define DO_BSR		(464)
#define DO_JSR		(465)
#define DO_LDAH		(466)
#define DO_LDAL		(467)
#define DO_LDALH	(468)
#define DO_LDAQ		(469)
#define DO_LDB		(470)
#define DO_LDD		(471)
#define DO_LDF		(472)
#define DO_LDG		(473)
#define DO_LDL		(474)
#define DO_LDLL		(475)
#define DO_LDQ		(476)
#define DO_LDQL		(477)
#define DO_LDQU		(478)
#define DO_LDS		(479)
#define DO_LDT		(480)
#define DO_LDW		(481)
#define DO_MB		(482)
#define DO_MRGB		(483)
#define DO_ZAP		(484)
#define DO_MSKBH	(485)
#define DO_MSKBL	(486)
#define DO_MSKLH	(487)
#define DO_MSKLL	(488)
#define DO_ZAPNOT	(489)
#define DO_MSKQH	(490)
#define DO_MSKQL	(491)
#define DO_MSKWH	(492)
#define DO_MSKWL	(493)
#define DO_MULD		(494)
#define DO_MULDC	(495)
#define DO_MULDS	(496)
#define DO_MULDSC	(497)
#define DO_MULDSU	(498)
#define DO_MULDSUC	(499)
#define DO_MULDU	(500)
#define DO_MULDUC	(501)
#define DO_MULF		(502)
#define DO_MULFC	(503)
#define DO_MULFS	(504)
#define DO_MULFSC	(505)
#define DO_MULFSU	(506)
#define DO_MULFSUC	(507)
#define DO_MULFU	(508)
#define DO_MULFUC	(509)
#define DO_MULG		(510)
#define DO_MULGC	(511)
#define DO_MULGS	(512)
#define DO_MULGSC	(513)
#define DO_MULGSU	(514)
#define DO_MULGSUC	(515)
#define DO_MULGU	(516)
#define DO_MULGUC	(517)
#define DO_MULL		(518)
#define DO_MULLV	(519)
#define DO_MULQ		(520)
#define DO_MULQV	(521)
#define DO_MULS		(522)
#define DO_MULSC	(523)
#define DO_MULSM	(524)
#define DO_MULSP	(525)
#define DO_MULSSU	(526)
#define DO_MULSSUC	(527)
#define DO_MULSSUI	(528)
#define DO_MULSSUIC	(529)
#define DO_MULSSUIM	(530)
#define DO_MULSSUIP	(531)
#define DO_MULSSUM	(532)
#define DO_MULSSUP	(533)
#define DO_MULSU	(534)
#define DO_MULSUC	(535)
#define DO_MULSUM	(536)
#define DO_MULSUP	(537)
#define DO_MULT		(538)
#define DO_MULTC	(539)
#define DO_MULTM	(540)
#define DO_MULTP	(541)
#define DO_MULTSU	(542)
#define DO_MULTSUC	(543)
#define DO_MULTSUI	(544)
#define DO_MULTSUIC	(545)
#define DO_MULTSUIM	(546)
#define DO_MULTSUIP	(547)
#define DO_MULTSUM	(548)
#define DO_MULTSUP	(549)
#define DO_MULTU	(550)
#define DO_MULTUC	(551)
#define DO_MULTUM	(552)
#define DO_MULTUP	(553)
#define DO_NOP		(554)
#define DO_NUDGE	(555)
#define DO_OR		(556)
#define DO_ORNOT	(557)
#define DO_RCC		(558)
#define DO_ROT		(559)
#define DO_SLL		(560)
#define DO_SRA		(561)
#define DO_SRL		(562)
#define DO_STB		(563)
#define DO_STD		(564)
#define DO_STF		(565)
#define DO_STG		(566)
#define DO_STL		(567)
#define DO_STLC		(568)
#define DO_STQ		(569)
#define DO_STQC		(570)
#define DO_STQU		(571)
#define DO_STS		(572)
#define DO_STT		(573)
#define DO_STW		(574)
#define DO_SUBD		(575)
#define DO_SUBDC	(576)
#define DO_SUBDS	(577)
#define DO_SUBDSC	(578)
#define DO_SUBDSU	(579)
#define DO_SUBDSUC	(580)
#define DO_SUBDU	(581)
#define DO_SUBDUC	(582)
#define DO_SUBF		(583)
#define DO_SUBFC	(584)
#define DO_SUBFS	(585)
#define DO_SUBFSC	(586)
#define DO_SUBFSU	(587)
#define DO_SUBFSUC	(588)
#define DO_SUBFU	(589)
#define DO_SUBFUC	(590)
#define DO_SUBG		(591)
#define DO_SUBGC	(592)
#define DO_SUBGS	(593)
#define DO_SUBGSC	(594)
#define DO_SUBGSU	(595)
#define DO_SUBGSUC	(596)
#define DO_SUBGU	(597)
#define DO_SUBGUC	(598)
#define DO_SUBL		(599)
#define DO_SUBLV	(600)
#define DO_SUBQ		(601)
#define DO_SUBQV	(602)
#define DO_SUBS		(603)
#define DO_SUBSC	(604)
#define DO_SUBSM	(605)
#define DO_SUBSP	(606)
#define DO_SUBSSU	(607)
#define DO_SUBSSUC	(608)
#define DO_SUBSSUI	(609)
#define DO_SUBSSUIC	(610)
#define DO_SUBSSUIM	(611)
#define DO_SUBSSUIP	(612)
#define DO_SUBSSUM	(613)
#define DO_SUBSSUP	(614)
#define DO_SUBSU	(615)
#define DO_SUBSUC	(616)
#define DO_SUBSUM	(617)
#define DO_SUBSUP	(618)
#define DO_SUBT		(619)
#define DO_SUBTC	(620)
#define DO_SUBTM	(621)
#define DO_SUBTP	(622)
#define DO_SUBTSU	(623)
#define DO_SUBTSUC	(624)
#define DO_SUBTSUI	(625)
#define DO_SUBTSUIC	(626)
#define DO_SUBTSUIM	(627)
#define DO_SUBTSUIP	(628)
#define DO_SUBTSUM	(629)
#define DO_SUBTSUP	(630)
#define DO_SUBTU	(631)
#define DO_SUBTUC	(632)
#define DO_SUBTUM	(633)
#define DO_SUBTUP	(634)
#define DO_UMULH	(635)
#define DO_XOR		(636)

#define DO_RC		(637)
#define DO_RS		(638)

#define DO_CVTQLSV	(639)

#define DO_S4ADDL	(640)
#define DO_S4ADDQ	(641)
#define DO_S8ADDL	(642)
#define DO_S8ADDQ	(643)

#define DO_S4SUBL	(644)
#define DO_S4SUBQ	(645)
#define DO_S8SUBL	(646)
#define DO_S8SUBQ	(647)

#define DO_CVTDG	(648)
#define DO_CVTDGC	(649)
#define DO_CVTDGU	(650)
#define DO_CVTDGUC	(651)

#define DO_CVTGD	(652)
#define DO_CVTGDS	(653)
#define DO_CVTGDU	(654)
#define DO_CVTGDC	(655)
#define DO_CVTGDUC	(656)
#define DO_CVTGDSC	(657)
#define DO_CVTGDSU	(658)
#define DO_CVTGDSUC	(659)

#define DO_RD_FPCTL	(660)
#define DO_WR_FPCTL	(661)
#define DO_MF_FPCR	(DO_RD_FPCTL)	/* synonyms */
#define DO_MT_FPCR	(DO_WR_FPCTL)	/* synonyms */

#define DO_CVTDGS	(662)
#define DO_CVTDGSC	(663)
#define DO_CVTDGSU	(664)
#define DO_CVTDGSUC	(665)

#define DO_CVTTQD	(666)
#define DO_CVTTQVD	(667)
#define DO_CVTTQSVD	(668)
#define DO_CVTTQSVID	(669)
#define DO_CVTTQM	(670)
#define DO_CVTTQVM	(671)
#define DO_CVTTQSVM	(672)
#define DO_CVTTQSVIM	(673)

/* V3.24 Following added to match HAL assembler DEFOPER.H */
#define DO_ADDSS	(674)
#define DO_SEXTB	(675)
#define DO_SEXTW	(676)
#define DO_CTPOP	(677)
#define DO_CTLZ		(678)
#define DO_CTTZ		(679)
#define DO_PERR		(680)
#define DO_MINUB8	(681)
#define DO_MINUW4	(682)
#define DO_MINSB8	(683)
#define DO_MINSW4	(684)
#define DO_MAXUB8	(685)
#define DO_MAXUW4	(686)
#define DO_MAXSB8	(687)
#define DO_MAXSW4	(688)
#define DO_UNPKBW	(689)
#define DO_UNPKBL	(690)
#define DO_PKWB		(691)
#define DO_PKLB		(692)
#define DO_WH64		(693)
#define DO_ECB		(694)
#define DO_ITOFT	(695)
#define DO_ITOFS	(696)
#define DO_ITOFF	(697)
#define DO_SQRTS	(698)
#define DO_SQRTSC	(699)
#define DO_SQRTSM	(701)
#define DO_SQRTSD	(702)
#define DO_SQRTSU	(703)
#define DO_SQRTSUC	(704)
#define DO_SQRTSUM	(705)
#define DO_SQRTSUD	(706)
#define DO_SQRTSSU	(707)
#define DO_SQRTSSUC	(708)
#define DO_SQRTSSUM	(709)
#define DO_SQRTSSUD	(710)
#define DO_SQRTSSUI	(711)
#define DO_SQRTSSUIC	(712)
#define DO_SQRTSSUIM	(713)
#define DO_SQRTSSUID	(714)
#define DO_SQRTT	(715)
#define DO_SQRTTC	(716)
#define DO_SQRTTM	(717)
#define DO_SQRTTD	(718)
#define DO_SQRTTU	(719)
#define DO_SQRTTUC	(720)
#define DO_SQRTTUM	(721)
#define DO_SQRTTUD	(722)
#define DO_SQRTTSU	(723)
#define DO_SQRTTSUC	(724)
#define DO_SQRTTSUM	(725)
#define DO_SQRTTSUD	(726)
#define DO_SQRTTSUI	(727)
#define DO_SQRTTSUIC	(728)
#define DO_SQRTTSUIM	(729)
#define DO_SQRTTSUID	(730)
#define DO_AMASK	(731)
#define DO_ADDSSC	(732)
#define DO_ADDSSM	(733)
#define DO_ADDSSD	(733)
#define DO_ADDTS	(734)
#define DO_ADDTSC	(735)
#define DO_ADDTSM	(736)
#define DO_ADDTSD	(737)
#define DO_FTOIT	(738)
#define DO_FTOIS	(739)
#define DO_IMPLVER	(740)
#define MAX_INDEX	(DO_IMPLVER+1)
#endif
